import 'dart:ffi';

import 'dart:typed_data';

class QueueMessage {
  String id;
  String appID;
  String robotID;
  String userID;
  QMType msgType;
  Uint8List payload;
  bool encrypted;

  QueueMessage({
    this.id,
    this.appID,
    this.robotID,
    this.userID,
    this.msgType,
    this.payload,
    this.encrypted,
  });

  factory QueueMessage.fromJson(Map<dynamic, dynamic> json) => QueueMessage(
        id: json["id"],
        appID: json["app_id"],
        robotID: json["robot_id"],
        userID: json["user_id"],
        msgType: QMType(json["msg_type"]),
        payload: json["payload"],
        encrypted: json["encrypted"],
      );

  Map<String, dynamic> toJson() => {
        "id": id,
        "app_id": appID,
        "robot_id": robotID,
        "user_id": userID,
        "msg_type": msgType,
        "payload": payload,
        "encrypted": encrypted,
      };
}

mixin ToAlias {}

class Stuff<T> {
  T value;
  Stuff(this.value);
}

class QMType = Stuff<int> with ToAlias;

final QMType QMT_Error = QMType(-1);
final QMType QMT_KeyExchange = QMType(0);
final QMType QMT_AppIn = QMType(1);
final QMType QMT_AppOut = QMType(2);
final QMType QMT_AppPush = QMType(3);
final QMType QMT_AppRequest = QMType(4);
final QMType QMT_RobotID = QMType(5);
